SystemOrganization addCategory: #'SourceCity-Importer'!

Object subclass: #SourceCityImporter
	instanceVariableNames: 'city districts buildings buildingsSelector heightSelector widthSelector heightNormalizer widthNormalizer id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!SourceCityImporter commentStamp: '<historical>' prior: 0!
I'm responsible for populating a city from a model (usually a ring model)!

!SourceCityImporter class methodsFor: 'default-model' stamp: 'DouailleErwan 6/28/2012 17:27'!
defaultModel
	
	^ self
		title: (City model: 'SourceCity default')
		strategy: SourceCityImporterStrategy default.
		! !

!SourceCityImporter class methodsFor: 'default-model' stamp: 'DouailleErwan 6/24/2012 19:56'!
title: aCityName cityDistrict: aCollection cityBuilding: aBuildingSelector buildingHeightNormalizer: aHeightNormalizer buildingWidthNormalizer: aWidthNormalizer buildingHeightSelector: aHeightSelector buildingWidthSelector: aWidthSelector
	
	^ self new 
		city: (City model: aCityName);
		buildingsSelector: aBuildingSelector;
		heightNormalizer: aHeightNormalizer;
		widthNormalizer: aWidthNormalizer;
		heightSelector: aHeightSelector;
		widthSelector: aWidthSelector;
		import: aCollection.
		! !

!SourceCityImporter class methodsFor: 'default-model' stamp: 'DouailleErwan 6/28/2012 17:27'!
title: aCityName strategy: aSourceCityImporterStrategy
	^ self new 
		city: (City model: aCityName);
		buildingsSelector: aSourceCityImporterStrategy;
		heightNormalizer: aSourceCityImporterStrategy;
		widthNormalizer: aSourceCityImporterStrategy;
		heightSelector: aSourceCityImporterStrategy;
		widthSelector: aSourceCityImporterStrategy;
		import: aSourceCityImporterStrategy.
		! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwan 6/22/2012 14:48'!
basicBuilding: aClassName district: aDistrict
	^ Building forModel: aClassName 
		inDistrict: aDistrict 
		id: self id
		heightSelector: self heightSelector 
		heightNormalizer: self heightNormalizer
		widthSelector: self widthSelector 
		widthNormalizer: self widthNormalizer! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwan 6/22/2012 14:48'!
basicDistrict: aPackageName city: aCity
	^District forPackage: (self packageNamed: aPackageName)
		inCity: aCity 
		id: self id.
	
	! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 13:23'!
buildings
	^ buildings! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 13:23'!
buildings: anObject
	buildings := anObject! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 15:44'!
buildingsSelector
	^ buildingsSelector! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 15:44'!
buildingsSelector: anObject
	buildingsSelector := anObject! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 13:23'!
city
	^ city! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 13:23'!
city: anObject
	city := anObject! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwan 6/12/2012 11:40'!
cityNamed: aName withPackageNames: aCol 

	self cityNamed: aName withPackageNames: aCol widthSelectorChoice: #'yourself' heightSelectorChoice: #'yourself'! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwan 6/12/2012 11:40'!
cityNamed: aName withPackageNames: aCol widthSelectorChoice: aSelectorw heightSelectorChoice: aSelectorh

	self cityNamed: aName withPackageNames: aCol widthSelectorChoice: aSelectorw heightSelectorChoice: aSelectorh colorMediumSelector: 20 colorHighSelector: 50 colorLow: (Color blue) colorMedium: (Color green)  colorHigh: (Color red) ! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwan 6/12/2012 11:40'!
cityNamed: aName withPackageNames: aCol widthSelectorChoice: aSelectorw heightSelectorChoice: aSelectorh colorMediumSelector: mediumValue colorHighSelector: highValue colorLow: aLowColor colorMedium: aMediumColor colorHigh: aHighColor


	self city: (City model: aName).
	self heightSelector: aSelectorh.
	self widthSelector: aSelectorw.
	self lowColor: aLowColor.
	self mediumColor: aMediumColor.
	self highColor: aHighColor.
	self mediumColorValue: mediumValue.
	self highColorValue: highValue.
	aCol do: [:each | self importPackageAsDistrict: each ].
	self importClassAsBuilding .! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 13:23'!
districts
	^ districts! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 13:23'!
districts: anObject
	districts := anObject! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwan 6/22/2012 14:49'!
ensureBuilding: aClassName district: aDistrict
	^ buildings
			at: aClassName 
			ifAbsent: [ 
				self idIncrement.		
				self buildings at: id put: (self basicBuilding: aClassName district: aDistrict)].
			
						! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwan 6/22/2012 14:48'!
ensureDistrict: aPackageName
	^districts 
			at: aPackageName 
			ifAbsent: [ 
				self idIncrement.
				self districts at: id put: (self basicDistrict: aPackageName city: (self city))].
			
						! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 13:23'!
heightNormalizer
	^ heightNormalizer! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 13:23'!
heightNormalizer: anObject
	heightNormalizer := anObject! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 13:23'!
heightSelector
	^ heightSelector! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 13:23'!
heightSelector: anObject
	heightSelector := anObject! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 13:23'!
id
	^ id! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 13:23'!
id: anObject
	id := anObject! !

!SourceCityImporter methodsFor: 'utils' stamp: 'DouailleErwan 6/18/2012 11:17'!
idIncrement
	self id: self id +1.
	^ self id! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwan 6/12/2012 14:19'!
import: aCollection
	aCollection do:[:each | self importPackageAsDistrict: each].
	self importClassAsBuilding.! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwan 6/12/2012 15:44'!
importClassAsBuilding
	(self city districts) do: [ :each |
		(each model perform: self buildingsSelector) do: [ :eachClass |
			eachClass isBehavior
				ifTrue: [self ensureBuilding: eachClass district: each. ]]
			displayingProgress: 'importing ', self buildingsSelector asString.
		].! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwan 6/12/2012 11:40'!
importClassAsBuilding: aClassName district: aDistrict
	
	self ensureBuilding: aClassName district: aDistrict.
	! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwan 6/12/2012 11:40'!
importPackageAsDistrict: aPackageName
	
	self ensureDistrict: aPackageName.
	! !

!SourceCityImporter methodsFor: 'initialize-release' stamp: 'DouailleErwan 6/12/2012 13:23'!
initialize
	super initialize.
	id := 0.
	districts := Dictionary new.
	buildings := Dictionary new.! !

!SourceCityImporter methodsFor: 'utils' stamp: 'DouailleErwan 6/12/2012 11:40'!
numberOfBuilding

	^ city districts inject: 0 into: [:sum :each | sum + each buildings size.].
! !

!SourceCityImporter methodsFor: 'utils' stamp: 'DouailleErwan 6/12/2012 11:40'!
numberOfDistrict
	^city districts size! !

!SourceCityImporter methodsFor: 'utils' stamp: 'DouailleErwan 6/12/2012 15:48'!
packageNamed: aString
	^ aString! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 13:23'!
widthNormalizer
	^ widthNormalizer! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 13:23'!
widthNormalizer: anObject
	widthNormalizer := anObject! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 13:23'!
widthSelector
	^ widthSelector! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 13:23'!
widthSelector: anObject
	widthSelector := anObject! !

SourceCityImporter subclass: #SourceCityRPackageImporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!SourceCityRPackageImporter commentStamp: '<historical>' prior: 0!
I'm responsible for populating a city from a model (usually a ring model)

Specially for RPackage import!

!SourceCityRPackageImporter class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 6/12/2012 15:49'!
defaultModel
	
	^ self new 
		city: (City model: 'SourceCity default');
		buildingsSelector: #classes;
		heightNormalizer: #sqrt;
		widthNormalizer: #sqrt;
		heightSelector: #selectors;
		widthSelector: #allInstVarNames;
		import: RPackageOrganizer default packageNames.! !

!SourceCityRPackageImporter class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 6/15/2012 12:48'!
title: aCityName cityDistrict: aCollection buildingHeightNormalizer: aHeightNormalizer buildingWidthNormalizer: aWidthNormalizer buildingHeightSelector: aHeightSelector buildingWidthSelector: aWidthSelector
	
	^ self new 
		city: (City model: aCityName);
		buildingsSelector: #classes;
		heightNormalizer: aHeightNormalizer;
		widthNormalizer: aWidthNormalizer;
		heightSelector: aHeightSelector;
		widthSelector: aWidthSelector;
		import: aCollection! !

!SourceCityRPackageImporter methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 6/12/2012 15:48'!
packageNamed: aString
	^ RPackageOrganizer default packageNamed: aString! !

Object subclass: #SourceCityImporterStrategy
	instanceVariableNames: 'buildingsSelector heightNormalizer widthNormalizer heightSelector widthSelector import'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!SourceCityImporterStrategy commentStamp: '<historical>' prior: 0!
I'm the object who is needed to SourceCityImporter!

!SourceCityImporterStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 6/28/2012 17:35'!
buildingsSelector
	^ buildingsSelector! !

!SourceCityImporterStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 6/28/2012 17:35'!
buildingsSelector: anObject
	buildingsSelector := anObject! !

!SourceCityImporterStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 6/28/2012 17:35'!
heightNormalizer
	^ heightNormalizer! !

!SourceCityImporterStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 6/28/2012 17:35'!
heightNormalizer: anObject
	heightNormalizer := anObject! !

!SourceCityImporterStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 6/28/2012 17:35'!
heightSelector
	^ heightSelector! !

!SourceCityImporterStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 6/28/2012 17:35'!
heightSelector: anObject
	heightSelector := anObject! !

!SourceCityImporterStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 6/28/2012 17:35'!
import
	^ import! !

!SourceCityImporterStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 6/28/2012 17:35'!
import: anObject
	import := anObject! !

!SourceCityImporterStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 6/28/2012 17:35'!
widthNormalizer
	^ widthNormalizer! !

!SourceCityImporterStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 6/28/2012 17:35'!
widthNormalizer: anObject
	widthNormalizer := anObject! !

!SourceCityImporterStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 6/28/2012 17:35'!
widthSelector
	^ widthSelector! !

!SourceCityImporterStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 6/28/2012 17:35'!
widthSelector: anObject
	widthSelector := anObject! !
